# spring-reactive-demo

Requirements
Java - 1.8.x

Maven - 3.x.x

MongoDB - 3.x.x

Steps to Setup
1. Clone the application
``
git clone https://gitlab.mynisum.com/vrajesh/spring-reactive-demo.git
``

2. Build and run the app using maven

``
cd spring-reactive-demo
``
``
mvn package
``
``
java -jar target/spring-reactive-demo-1.0-SNAPSHOT.jar
``

Alternatively, you can run the app without packaging it using -

``
mvn spring-boot:run
``

``
The server will start at http://localhost:8080.
``

Exploring the Rest APIs
The application defines following REST APIs

``
1. GET /myTweets - Get All Tweets
``
``
2. POST /createTweet - Create a new Tweet
``
``
3. GET /myTweets/{tweetId} - Retrieve a Tweet by Id
``
``
4. PUT /myTweets/{tweetId} - Update a Tweet
``
``
5. DELETE /myTweets/{tweetId} - Delete a Tweet
``
``
6. GET /stream/tweets - Stream tweets to a browser as Server-Sent Events
``

Running integration tests

``
The project also contains integration tests for all the Rest APIs. For running the integration tests, go to the root directory of the project and type mvn test in your terminal.
``